=== debian/changelog ===
kfreebsd-8 (8.2-15) unstable; urgency=low

  * Build udebs for the installer.

 -- Robert Millan <rmh@debian.org>  Fri, 25 Nov 2011 19:01:44 +0100

kfreebsd-8 (8.2-14) unstable; urgency=high

  * Fix installability problem on non-kfreebsd platforms.

 -- Robert Millan <rmh@debian.org>  Fri, 18 Nov 2011 19:28:47 +0100

kfreebsd-8 (8.2-13) unstable; urgency=low

  * Remove gen-ld-u-options / 020_linker.diff kludge, replace it with
    backport of upstream fix (r215137).
  * Mark kfreebsd-headers-@version@-@abiname@ as kfreebsd-any.
  * Depend on package providing devd.

 -- Robert Millan <rmh@debian.org>  Tue, 08 Nov 2011 21:52:27 +0100

kfreebsd-8 (8.2-12) unstable; urgency=low

  * Enable TEKEN_XTERM.
  * Backport libteken and syscons from 9-STABLE (r226626).
  * Recover 918_delete_key.diff patch from r3199.  (Closes: #605065)

 -- Robert Millan <rmh@debian.org>  Tue, 01 Nov 2011 13:51:36 +0100

kfreebsd-8 (8.2-11) unstable; urgency=low

  [ Aurelien Jarno ]
  * Update 000_unix_socket_overflow.diff from the second security advisory,
    fixing the same issue on the Linux compatibility layer. Closes: #645377.

  [ Robert Millan ]
  * Fix panic on early boot.  (Closes: #644417)
    - Switch back to GCC 4.4.
    - Turn optimization down to -O1 (901_disable_optimization_2.diff).
  * Remove 907_cpu_class.diff (it breaks FreeBSD userland when running
    in a chroot on Debian kernel).

 -- Robert Millan <rmh@debian.org>  Thu, 27 Oct 2011 21:49:27 +0200

kfreebsd-8 (8.2-10) unstable; urgency=low

  [ Robert Millan ]
  * Disable -frename-registers on i386.  I enabled it in 2006 only because I
    mistakenly thought upstream had done the same.  In fact, upstream only
    enabled this flag on amd64.  See SVN revision 1302.

  [ Petr Salinger ]
  * Add 918_unix_socket_overflow.diff, to fix up breakage in our userland
    after 000_unix_socket_overflow.diff. Closes: #645527.

 -- Robert Millan <rmh@debian.org>  Mon, 17 Oct 2011 20:32:16 +0200

kfreebsd-8 (8.2-9) unstable; urgency=high

  * 000_unix_socket_overflow.diff: Fix for FreeBSD-SA-11:05.unix.
    (Closes: #645377)

 -- Robert Millan <rmh@debian.org>  Sun, 16 Oct 2011 10:44:30 +0200

kfreebsd-8 (8.2-8) unstable; urgency=high

  [ Petr Salinger ]
  * extend ld_target detection

  [ Robert Millan ]
  * Fix panic on early boot.  (Closes: #644417)
    - Switch back to GCC 4.4
    - 005_gcc46.diff: Add -fno-gcse to COPTFLAGS to fix GCC >= 4.4 builds.

 -- Robert Millan <rmh@debian.org>  Sat, 08 Oct 2011 01:01:34 +0200

kfreebsd-8 (8.2-7) unstable; urgency=low

  * Replace msk backport patch with version from 8-STABLE (instead of
    9-CURRRENT).
  * Fix a pair of FTBFS on hurd-i386.
  * Provide "kfreebsd-headers" virtual package in kfreebsd-headers-
    @version@-@abiname@-@flavor@.
  * Loosen freebsd-utils dependency (8.1-5 already provides proper devd
    support now that #630614 has been backported).
  * 000_proc_swaps.diff: Implement /proc/swaps.

 -- Robert Millan <rmh@debian.org>  Mon, 08 Aug 2011 12:19:45 +0000

kfreebsd-8 (8.2-6) unstable; urgency=low

  * Only depend on freebsd-utils and kldutils on [kfreebsd-any].
  * 002_maxpathlen.diff: Fix FTBFS on hurd-i386.
  * Remove versioned dependency that confused buildds.

 -- Robert Millan <rmh@debian.org>  Sun, 10 Jul 2011 02:09:59 +0200

kfreebsd-8 (8.2-5) unstable; urgency=low

  * Disable buggy 009_disable_duped_modules.diff.  It was disabling many
    more modules than built into kernel (e.g. all USB modules).
  * Build-depend on sane versions of freebsd-buildutils (see #632600).

 -- Robert Millan <rmh@debian.org>  Mon, 04 Jul 2011 21:52:38 +0200

kfreebsd-8 (8.2-4) unstable; urgency=low

  * Add sys/conf/kmod_syms.awk, sys/kern/bus_if.m, sys/dev/pci/pci_if.m,
    sys/kern/device_if.m, sys/tools/makeobjops.awk and sys/machine symlink
    to header package.
  * Require either libsbuf-dev or kfreebsd-kernel-headers that provides
    a valid <sys/sbuf.h>.
  * Remove drivers for USB devices from kernel, now that devd autoloads
    them.
  * Extend ldscript non-kFreeBSD fix to support mipsel.
  * Allow building module-less kernels (needed for mipsel).
  * 000_uhid_nomatch.diff: Cherry-pick from HEAD (Fix for "nomatch" event
    for ums and ukbd drivers when uhid is loaded).

 -- Robert Millan <rmh@debian.org>  Sun, 03 Jul 2011 15:40:09 +0200

kfreebsd-8 (8.2-3) unstable; urgency=medium

  * Fix net802.11 stack kernel memory disclosure (CVE-2011-2480).
    (Closes: #631160)
    - 000_net80211_disclosure.diff

 -- Robert Millan <rmh@debian.org>  Fri, 24 Jun 2011 16:24:58 +0200

kfreebsd-8 (8.2-2) unstable; urgency=low

  [ Guillem Jover ]
  * Now using Standards-Version 3.9.2 (no changes needed).
  * Switch to source format “3.0 (quilt)”.
    - Remove quilt from Build-Depends.
    - Remove patch target in debian/rules.
    - Remove now unneeded README.source.
    - Refresh all patches.

  [ Robert Millan ]
  * Add lintian override for "embedded-library" (zlib.ko).
  * Automatically propagate GCC version dependency to debian/control.
  * Add "(meta-package)" to Description of meta-packages to make lintian happy.
  * Add myself to Uploaders.
  * Build by GCC 4.6.  (Closes: #594288)
  * Add conf/kern.mk, conf/kmod.mk, kern/vnode_if.src, and
    tools/vnode_if.awk to kfreebsd-headers-8.2-1.  (Closes: #630509)
  * Merge backported if_msk driver from HEAD.  (Closes: #628954)
    - 000_msk_backport_from_HEAD.diff

  [ Petr Salinger ]
  * Add 111_linprocfs_kthread.diff. Closes: #630104.

 -- Robert Millan <rmh@debian.org>  Fri, 17 Jun 2011 15:35:49 +0200

kfreebsd-8 (8.2-1) unstable; urgency=low

  [ Robert Millan ]
  * New upstream release.
    - 000_adaptive_machine_arch.diff: Remove (merged).
    - 000_ata.diff: Remove (merged).
    - 000_ufs_lookup.diff: Remove (merged).
    - 004_xargs.diff: Resync.
    - 102_POLL_HUP.diff: Remove (merged).
    - 104_linprocfs.diff: Remove (merged).
    - 904_dev_full.diff: Resync.
    - 999_firmware.diff: Resync.

